"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _envinfo() {
  const data = _interopRequireDefault(require("envinfo"));

  _envinfo = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @ts-ignore
const packageJSON = require('../../package.json');

async function action() {
  const info = await _envinfo().default.run({
    System: ['OS', 'Shell'],
    Binaries: ['Node', 'Yarn', 'npm', 'Watchman'],
    IDEs: ['Xcode', 'Android Studio'],
    npmPackages: ['expo', 'react', 'react-dom', 'react-native', 'react-native-web', 'react-navigation', '@expo/webpack-config'],
    npmGlobalPackages: ['expo-cli']
  }, {
    title: `Expo CLI ${packageJSON.version} environment info`
  });
  console.log(info);
}

function _default(program) {
  program.command('diagnostics [path]').description('Log environment info to the console').helpGroup('info').asyncAction(action);
}
//# sourceMappingURL=diagnostics.js.map