"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fallbackToUrl = fallbackToUrl;
exports.learnMore = learnMore;

function _terminalLink() {
  const data = _interopRequireDefault(require("terminal-link"));

  _terminalLink = function () {
    return data;
  };

  return data;
}

function _log() {
  const data = _interopRequireDefault(require("../../log"));

  _log = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * When linking isn't available, fallback to just displaying the URL.
 *
 * @example https://expo.io
 * @example [value](https://expo.io)
 *
 * @param value
 * @param url
 */
function fallbackToUrl(value, url) {
  return (0, _terminalLink().default)(value, url, {
    fallback: (text, url) => url
  });
}
/**
 * When linking isn't available, format the learn more link better.
 *
 * @example Learn more: https://expo.io
 * @example [Learn more](https://expo.io)
 * @param url
 */


function learnMore(url) {
  return (0, _terminalLink().default)(_log().default.chalk.underline('Learn more.'), url, {
    fallback: (text, url) => `Learn more: ${_log().default.chalk.underline(url)}`
  });
}
//# sourceMappingURL=TerminalLink.js.map